Index: include/libroar/basic.h
===================================================================
--- include/libroar/basic.h	(revision 2043)
+++ include/libroar/basic.h	(revision 3348)
@@ -1,6 +1,6 @@
-//libroarbasic.h:
+//basic.h:
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/buffer.h
===================================================================
--- include/libroar/buffer.h	(revision 3022)
+++ include/libroar/buffer.h	(revision 3348)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/client.h
===================================================================
--- include/libroar/client.h	(revision 2812)
+++ include/libroar/client.h	(revision 3348)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/ctl.h
===================================================================
--- include/libroar/ctl.h	(revision 2615)
+++ include/libroar/ctl.h	(revision 3348)
@@ -1,6 +1,6 @@
-//auth.h:
+//ctl.h:
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/meta.h
===================================================================
--- include/libroar/meta.h	(revision 3058)
+++ include/libroar/meta.h	(revision 3348)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/simple.h
===================================================================
--- include/libroar/simple.h	(revision 2697)
+++ include/libroar/simple.h	(revision 3348)
@@ -1,6 +1,6 @@
-//libroar.h:
+//simple.h:
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/stream.h
===================================================================
--- include/libroar/stream.h	(revision 3213)
+++ include/libroar/stream.h	(revision 3348)
@@ -1,6 +1,6 @@
-//libroarstream.h:
+//stream.h:
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_ctl.h
===================================================================
--- include/libroar/vio_ctl.h	(revision 2858)
+++ include/libroar/vio_ctl.h	(revision 3348)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_select.h
===================================================================
--- include/libroar/vio_select.h	(revision 1506)
+++ include/libroar/vio_select.h	(revision 3348)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_stdio.h
===================================================================
--- include/libroar/vio_stdio.h	(revision 2059)
+++ include/libroar/vio_stdio.h	(revision 3348)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: include/libroar/vio_string.h
===================================================================
--- include/libroar/vio_string.h	(revision 3030)
+++ include/libroar/vio_string.h	(revision 3348)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,